<?php
/*
Plugin Name: RoadRunner Rss Reader
Plugin URI: not-existant
Description: Always up to date NetNewsExpress Rss Reader
Author: MrFloppi ( Julius Linnenbaum )
Sponsor: www.infokriegernews.de
Version: 0.2
Author URI: http://www.net-news-express.de

This is a WordPress plugin (http://wordpress.org) and widget
*/

class TDataCom{
    private $host       = null;
    private $port       = null;
    private $user       = null;
    private $pass       = null;
    private $timeout    = null;
    private $ua         = null;
    public  $path       = null;
    private $query      = null;
    private $scheme     = null;
    private $orgUrl     = null;
    private $referer    = null;
    private $proxy      = null;
    
    private $format     = null;
    private $stream     = null;
    public  $head       = null;
    
    public  $errorNr    = null;
    public  $errorStr   = null;
    
    public  $content    = null;
    public  $header     = null;
    public  $title      = null;
    public  $contentStr = "";
    public  $typeAcc    = null;
    
    public  $formArray  = array();
    public  $metaTags   = array();
    
    public  $isOk       = true;
    public  $redirect   = null;
    public  $cookie     = null;
    public  $allowTypes = array("jpg","jpeg","gif","png","pdf");
    
    public $streamingError = false;
    
    //dokumentinformationen
    public  $_docLinks  = array();
    public  $_docForms  = array();
    
    function __construct($host, $formArray = array(), $method = "POST", $ua=false, $format = 1, $timeout = 30, $proxy = false,$cookie = null){
      $this->request($host, $formArray, $method, $ua, $format, $timeout,$proxy,$cookie);
    }
    
    function request($host, $formArray = array(), $method = "POST", $ua=false, $format = 1, $timeout = 30, $proxy = false,$cookie = null){
        if($cookie) $this->cookie = $cookie;
        $this->orgUrl    = $host;
        $url_info        = parse_url($host);
        $this->port      = (isset($url_info['port'])) ? $url_info['port'] : 80;        
        $this->host      = (isset($url_info['host'])) ? $url_info['host']: "127.0.0.1";
        $this->timeout   = $timeout;
        $this->proxy     = ($proxy)?true:false;
        $this->user      = (isset($url_info['user']))?$url_info['user']: null;
        $this->pass      = (isset($url_info['pass']))?$url_info['pass']: null;
        
        $this->path      = (isset($url_info['path']))?$url_info['path']: null;
        $this->query     = (isset($url_info['query']))?$url_info['query']: null;
        
        $this->format    = $format;
        $this->formArray = $formArray;
        $this->typeAcc   = (isset($url_info['scheme']))?$url_info['scheme']:"";
        //$this->referer   = $host;
        
        $this->ua        = $ua;
        
        switch($this->typeAcc){        // weiter
            case 'https' : $this->scheme = "ssl://"; break;
            default      : $this->scheme = "";       break;
        }
        
        $this->openSocket(); 
        if($this->isOk){
          switch($method){
              case "GET"  : $this->setHead_get();  break;
              case "POST" : $this->setHead_post(); break;
          }
          $this->sendHead();   
          $this->readStream(); 
          $this->checkRedirect();
          $this->grepTitle();  
          $this->closeSocket();
        

          $this->referer   = $this->typeAcc."://".$this->host.":".$this->port.$this->path.$this->query;
        }
        //$this->decodeLinks();  lieber erst bei bedarf decodieren
        //$this->decodeForms();
        //$this->decodeBody();   
    }
    
    function ua(){
        switch($this->ua){
            case "firefox" : $ref = "Mozilla/5.0 (Windows; N; Windows NT 5.1; de; rv:1.8.1.9) Gecko/20071025 Firefox/2.0.0.9";                                                   break;
            case "ie"      : $ref = "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; SLCC1; .NET CLR 2.0.50727; Media Center PC 5.0; .NET CLR 3.0.04506; .NET CLR 1.1.4322)"; break;
            default        : $ref = "manazOne BrowserAPI";                                                                                                   break;
        }
        
        return $ref;
    }
    
    function openSocket(){
        if($this->proxy){
            $pices = explode(".",$this->path);
            $key = array_search($pices[count($pices)-1],$this->allowTypes);
            if($key===false) die("UNG&Uuml;LTIGES DATEIFORMAT");
        }
        $ok = true;
        if($this->host === NULL)        $ok = false;
        if(!is_numeric($this->port))    $ok = false;
        if(!is_numeric($this->timeout)) $ok = false;
        
        $this->stream=@fsockopen($this->scheme.$this->host, $this->port, $this->errorNr, $this->errorStr, 5);
        if($this->stream==false){
         $this->isOk = false;
        } else {
          stream_set_timeout($this->stream,5);
        }
    }
    
    function closeSocket(){
        fclose($this->stream);
    }
    
    function errorOutput(){
        print "alert('";
        print "$this->errorNr \\n";
        print "$this->errorStr \\n";
        print "');";
        die();
    }
    
    function grepTitle(){
         preg_match('|<title>([^<]*?)</title>|is', $this->contentStr, $title);
         $this->title = (isset($title[1]))?trim($title[1]):"Ohne Titel";
    }
    
    function setHead_get(){
        if (!empty($this->user)) {
            $authentification = base64_encode($this->user.':'.$this->pass);
            $authline = "Authorization: Basic $authentification\r\n";
        }

        
        $ua = "User-Agent: ".$this->ua()."\r\n";
        if($this->referer!==null) $ref = "Referer: $this->referer\r\n";
        
           
        $this->head = "GET ".(($this->path)?$this->path:"/")."".(($this->query)?"?$this->query":"")." HTTP/1.1\r\n";         //?".$this->query."
        
        if (!empty($this->port)) $this->head .= "Host: ".$this->host.":".$this->port."\r\n";
        else                     $this->head .= "Host: ".$this->host."\r\n";
        
        if($this->cookie){
          $this->head .= "Cookie: ".join("; ",$this->cookie)."\r\n";          
        };
        $this->head .= "Connection: Close\r\n";
        $this->head .= "Accept: */*\r\n";
        
        if(isset($ua))          $this->head .= $ua;
        if(isset($ref))         $this->head .= $ref;
        if(isset($authline))    $this->head .= $authline;
        $this->head .= "\r\n";
        
    }
    
    function setHead_post(){
        if (!empty($this->user)) {
            $authentification = base64_encode($this->user.':'.$this->pass);
            $authline = "Authorization: Basic $authentification\r\n";
        }

        $ua = "User-Agent: ".$this->ua()."\r\n";
        if($this->referer!==null) $ref = "Referer: $this->referer\r\n"; 
        
        $body = $this->_code_post_vars();
           
        $this->head = "POST ".(($this->path)?$this->path:"/")."".(($this->query)?"?$this->query":"")." HTTP/1.0\r\n";         //?".$this->query."
        
        if (!empty($this->port)) $this->head .= "Host: ".$this->host.":".$this->port."\r\n";
        else                     $this->head .= "Host: ".$this->host."\r\n";
        
        if(isset($ua))          $this->head .= $ua;   
        if(isset($ref))         $this->head .= $ref;
        if(isset($authline))    $this->head .= $authline;

        if($this->cookie){
          $this->head .= "Cookie: ".join("; ",$this->cookie)."\r\n";          
        };
        $this->head .= "Connection: Close\r\n"; 
        
        $this->head .= "Content-Type: application/x-www-form-urlencoded\r\n";
        $this->head .= "Content-Length: ".strlen($body)."\r\n\r\n";
        $this->head .= $body."\r\n";
        

        $this->head .= "\r\n";        
    }
    
    function sendHead(){  
        fputs($this->stream, $this->head); 
    }
    
    function readStream(){
        $eoheader = false;
        $headers  = array();
        $headerStr = array();
        $content  = array();
        
        $cLength=-1;
        $cRead=0;
        $chunkedEncoding=false;
        
        //header
        $metaData = array("timed_out" => false);
        while(!feof($this->stream)&&!$metaData["timed_out"]){
          $metaData = stream_get_meta_data($this->stream);
          if(!$metaData["timed_out"]&&$data=fgets($this->stream)){
            //showRunTime(str_replace("<","&lt;","'$data'"));
            $headerStr[]=$data;
            $data=trim($data);
            if ($data == "") break; // header ende

            $parse = explode(':',$data); 
            $key = strtolower($parse[0]);
                        
            if($key=="content-length")$cLength=0+$parse[1];
            if($key=="transfer-encoding" && $parse[1]==" chunked")$chunkedEncoding=true;
            if($key=="set-cookie"){
              $c=substr($data,strlen($key)+2);
              $c=str_replace("path=/","",$c);
              $c=explode('; ',$c);
              if(is_array($this->cookie)) $this->cookie=array_merge($this->cookie,$c);
              else $this->cookie=$c;
            
            };
            
            if($this->format==1){
              if($key==$data)$headers[]=$data;
              else $headers[$key]=substr($data,strlen($key)+2);
            }
            else $headers[]=$data;                
          } else if($metaData["timed_out"]==true) $this->isOk = false;
        }
        
        // content
        if($chunkedEncoding){
        // chunked content
          $c="";
          while(!feof($this->stream)&&!$metaData["timed_out"]) {
            $metaData = stream_get_meta_data($this->stream);
            if(!$metaData["timed_out"]&&$cHead=fgets($this->stream)){
              $cHead = trim($cHead);
              if($cHead>""){
                $len = hexdec ($cHead);
                if($len==0)break; // last
                while(!feof($this->stream)&&$len>0){
                  $s= fread($this->stream,$len);              
                  $c.=$s;
                  $len-=strlen($s);
                };
              }
            }
          };
          $this->contentStr=$c;
          $content=explode("\n",str_replace("\r","",$c));          
        }
        
        else if($cLength>0){
        // content length
          $c = fread($this->stream,$cLength);
          $this->contentStr=$c;
          $content=explode("\n",str_replace("\r","",$c)) ;
          //showRunTime(str_replace("<","&lt;","'$c'"));
        }
        
        else if($cLength==0){
          // nix mehr
        } 
        else { 
        // no content length
          $c="";
          while(!$metaData["timed_out"]&&!feof($this->stream)){
            $metaData = stream_get_meta_data($this->stream);
            if(!$metaData["timed_out"]&&$data=fgets($this->stream)){
              $content[]             = $data; 
              $c.= $data;   
            }
          }
          $this->contentStr=$c;
        }        

        $this->content = $content;
        $this->header  = $headers;    
        $this->headerStr = $headerStr;    
    }
    
    function checkRedirect(){
        if(preg_match("'<meta[\s]*http-equiv[^>]*?content[\s]*=[\s]*[\"\']?\d+;[\s]*URL[\s]*=[\s]*([^\"\']*?)[\"\']?>'i",$this->contentStr,$match)) $this->redirect = $this->links($match[1],$this->orgUrl);     
    }
    
    function links($links,$URI){       
        preg_match("/^[^\?]+/",$URI,$match);

        $match = preg_replace("|/[^\/\.]+\.[^\/\.]+$|","",$match[0]);
        $match = preg_replace("|/$|","",$match);
        $match_part = parse_url($match);
        $match_root = $match_part["scheme"]."://".$match_part["host"];
                
        $search = array("|^http://".preg_quote($this->host)."|i",
                        "|^(\/)|i",
                        "|^(?!http://)(?!mailto:)|i",
                        "|/\./|",
                        "|/[^\/]+/\.\./|"
                       );
                        
        $replace = array("",
                         $match_root."/",
                         $match."/",
                         "/",
                         "/"
                        );            
                
        $link = preg_replace($search,$replace,$links);

        return $link;
    }
    
    function decodeBody ($eol = "\r\n" ){
        $check = true;
        $tmp = $this->contentStr;
        $add = strlen ( $eol );
        $this->contentStr = "";
        if ((isset($this->header["transfer-encoding"]))&&($this->header["transfer-encoding"]=="chunked")){
            while(!empty($check)){
                $tmp = ltrim ( $tmp );
                $pos = strpos ( $tmp, $eol );
                $len = hexdec ( substr ( $tmp, 0, $pos ) );
                if ( isset ( $this->header["content-encoding"] ) ) $this->contentStr .= gzinflate ( substr ( $tmp, ( $pos + $add + 10 ), $len ) );
                else                                               $this->contentStr .= substr ( $tmp, ( $pos + $add ), $len );
     
                $tmp = substr ( $tmp, ( $len + $pos + $add ) );
                $check = trim ( $tmp );
            }
        }
        else if ( isset ( $this->header["content-encoding"] ) ) $this->contentStr = gzinflate ( substr ( $tmp, 10 ) );
        else                                                    $this->contentStr = $tmp;
    }
    
    function decodeLinks(){    
        preg_match_all("'<\s*a\s.*?href\s*=\s*            # find <a href=
                        ([\"\'])?                         # find single or double quote
                        (?(1) (.*?)\\1 | ([^\s\>]+))      # if quote found, match up to next matching
                                                          # quote, otherwise match up to next space
                        'isx",$this->contentStr,$links);


        while(list($key,$val) = each($links[2])) if(!empty($val)) $links[] = $val;                     
        while(list($key,$val) = each($links[3])) if(!empty($val)) $links[] = $val;
                
        return $this->_docLinks = $links;
    }
    
    function decodeForms(){    
        preg_match_all("'<\/?(FORM|INPUT|SELECT|TEXTAREA|(OPTION))[^<>]*>(?(2)(.*(?=<\/?(option|select)[^<>]*>[\r\n]*)|(?=[\r\n]*))|(?=[\r\n]*))'Usi",$this->contentStr,$elements);

        $forms = implode("\r\n",$elements[0]);

        $this->_docForms = $forms;
    }
    
    function _code_post_vars(){
        $postdata = "";
        
        while(list($key,$val) = each($this->formArray)){
            if(is_array($val) || is_object($val)){
                        while(list($cur_key, $cur_val) = each($val)) {
                            $postdata .= urlencode($key)."[]=".urlencode($cur_val)."&";
                        }
            } 
            else $postdata .= urlencode($key)."=".urlencode($val)."&";
        }
        
        return $postdata;
    }
}

function widget_roadrunner_rss_init() {
 global $rssUrls;
    if ( !function_exists('register_sidebar_widget')) return;
    function widget_roadrunner_rss_output($args) {
       $dbUrl = "http://www.net-news-express.de/nne_roadrunner.php?t&imgUrl=".base64_encode(WP_PLUGIN_URL."/nne_roadrunner/images");
       $arrForm = array();
       
       $boolIsActive     = get_option("nne_runner_active");
       $boolLastInActive = get_option("nne_runner_inactivets");
       $boolLastUpdate   = get_option("nne_runner_lastupdatets");
       $timetoWait = 5*60;
       
       $html = get_option("nne_runner_htmlcode");
       if(floor(microtime(true))>$boolLastInActive+$timetoWait){
        update_option("nne_runner_active","TRUE");
        $boolIsActive = "TRUE";
       }
       
       if($boolIsActive==="TRUE"){
         if(floor(microtime(true))>$boolLastUpdate+$timetoWait){
           $html = "<script type='text/javascript'>";
           $dataCom = new TDataCom($dbUrl,$arrForm,'GET');
           if($dataCom->isOk){
             $html .= $dataCom->contentStr;
             update_option("nne_runner_lastupdatets",floor(microtime(true)));
             update_option("nne_runner_htmlcode",$html."</script>");
           } else {
             update_option("nne_runner_active","FALSE");
             update_option("nne_runner_inactivets",floor(microtime(true)));
           }
           $html .= "</script>";
         }
       }
       if(!$html||$html==""){
          $html = get_option("nne_runner_htmlcode");
       }
       
       $title = "";
       echo $before_widget;
       echo $before_title . $title . $after_title;
       echo $html;
       echo $after_widget;
    }
    register_sidebar_widget('RoadRunner Rss Reader', 'widget_roadrunner_rss_output');
}

add_action('plugins_loaded', 'widget_roadrunner_rss_init');

?>